#!/usr/bin/env python

import _padlockcrypto
import padlockcrypto

__metaclass__=type

class padlockrng:
	available = 0
	def __init__(self):
		self.available = padlockcrypto.padlock_rng_available()
	def getrng(self,num=1):
		if isinstance(num, int):
			rngnum,stat = padlockcrypto.python_rng_gen(num)
		else:
			rngnum = 'err'
			stat = 0
		return (rngnum,stat)

class padlockaes:
	available = 0
	available2 = 0
	aeskey=''
	aeslen=128
	aesiv=''
	aesmode=''
	def __init__(self):
		self.available = _padlockcrypto.padlock_ace_available()
		self.available2 = _padlockcrypto.padlock_ace2_available()
	def aes_setkey(self,aes_key='hello,padlock',aes_len=128):
		stat = 0
		if isinstance(aes_key, str) and isinstance(aes_len, int):
			strlen = len(aes_key)
			keylen = [128,192,256]
			if aes_len in keylen:
				maxlen = aes_len/8
				if strlen > 0 and strlen <= maxlen:
					self.aeskey = aes_key.encode('hex')
					self.aeslen = aes_len
					stat = 1
		return stat

	def aes_setmodeiv(self,aes_mode='CBC',aes_iv='0000000000000000'):
		stat = 0
		if isinstance(aes_mode, str) and isinstance(aes_iv, str):	
			strlen=len(aes_iv)
			MODE = ['CBC','ECB','CFB','OFB','CTR']
			if strlen == 16 and aes_mode in MODE:
				self.aesiv = aes_iv.encode('hex')
				self.aesmode = aes_mode
				stat = 1
			elif aes_mode == 'ECB':
				iv = '0000000000000000'
				self.aesiv = iv.encode('hex')
				self.aesmode = aes_mode
				stat = 1
			else:
				stat = 0
		return stat

	def aes_encrypt(self,text):
		if isinstance(text, str) and text != '':
			strlen = len(text);
			cipher,stat = padlockcrypto.python_aes_encrypt(text,strlen,self.aesmode,self.aeslen,self.aeskey,self.aesiv)
		else:
			cipher = 'err'
			stat = 0;
		return (cipher,stat)
		
	def aes_decrypt(self,text):
		if isinstance(text, str) and text != '':
			strlen = len(text)
			plain,stat = padlockcrypto.python_aes_decrypt(text,strlen,self.aesmode,self.aeslen,self.aeskey,self.aesiv)
		else:
			plain = 'err'
			stat = 0
		return (plain,stat)
		

class padlocksha1:
	available = 0
	partial_available = 0
	partialhash = ''
	sha1lenth = 0
	def __init__(self):
		self.available = _padlockcrypto.padlock_phe_available()
		self.partial_available =  _padlockcrypto.padlock_phe_partial_available()
	def sha1(self,src):
		if isinstance(src,str):
			strlen=len(src)
			sha1hash,stat =  _padlockcrypto.python_sha1(src,strlen)
		else:
			sha1hash='err'
			stat = 0
		return (sha1hash,stat)

	def sha1_partial_init(self,init_hash='67452301efcdab8998badcfe10325476c3d2e1f0'):
		self.partialhash = init_hash
		self.sha1lenth = 0;

	def sha1_partial_updata(self,src):
		if isinstance(src,str):
			strlen=len(src)
			self.partialhash,self.sha1length,stat = _padlockcrypto.python_sha1_partial_updata(self.partialhash,src,strlen)
		else:
			self.partialhash = 'err'
			self.sha1length = 0
			stat = 0
		return (self.sha1length,stat)

	def sha1_partial_final(self,src,lastlen):
		if isinstance(src,str) and self.partialhash != 'err':
			strlen=len(src)
			self.partialhash,stat = _padlockcrypto.python_sha1_partial_final(self.partialhash,src,strlen,lastlen)
		else:
			self.partialhash = 'err'
			stat = 0
		return (self.partialhash,stat)
			

class padlocksha256:
	available = 0
	partial_available = 0
	partialhash=''
	sha256length = 0
	def __init__(self):
		self.available = _padlockcrypto.padlock_phe_available()
		self.partial_available =  _padlockcrypto.padlock_phe_partial_available()
	def sha256(self,src):
		if isinstance(src,str):
			strlen = len(src)
			sha256hash,stat =  _padlockcrypto.python_sha256(src,strlen)
		else:
			sha256hash='err'
			stat = 0
		return (sha256hash,stat)

	def sha256_partial_init(self,init_hash='6a09e667bb67ae853c6ef372a54ff53a510e527f9b05688c1f83d9ab5be0cd19'):
		self.partialhash = init_hash
		self.sha256lenth = 0;

	def sha256_partial_updata(self,src):
		if isinstance(src,str):
			strlen = len(src)
			self.partialhash,self.sha256length,stat = _padlockcrypto.python_sha256_partial_updata(self.partialhash,src,strlen)
		else:
			self.partialhash = 'err'
			self.sha256length = 0
			stat = 0
		return (self.sha256length,stat)

	def sha256_partial_final(self,src,lastlen):
		if isinstance(src,str) and self.partialhash != 'err':
			strlen = len(src)
			self.partialhash,stat = _padlockcrypto.python_sha256_partial_final(self.partialhash,src,strlen,lastlen)
		else:
			self.partialhash = 'err'
			stat = 0
		return (self.partialhash,stat)

class padlocksha384:
	available = 0
	partial_available = 0
	partialhash=''
	sha384length = 0
	def __init__(self):
		self.available = _padlockcrypto.padlock_phe_available()
		self.partial_available =  _padlockcrypto.padlock_phe_partial_available()
	def sha384(self,src):
		if isinstance(src,str):
			strlen = len(src)
			sha384hash,stat =  _padlockcrypto.python_sha384(src,strlen)
		else:
			sha384hash='err'
			stat = 0
		return (sha384hash,stat)

class padlocksha512:
	available = 0
	partial_available = 0
	partialhash=''
	sha512length = 0
	def __init__(self):
		self.available = _padlockcrypto.padlock_phe_available()
		self.partial_available =  _padlockcrypto.padlock_phe_partial_available()
	def sha512(self,src):
		if isinstance(src,str):
			strlen = len(src)
			sha512hash,stat =  _padlockcrypto.python_sha512(src,strlen)
		else:
			sha512hash='err'
			stat = 0
		return (sha512hash,stat)

class padlockpmm:
	available = 0
	available2 = 0
	def __init__(self):
		self.available = _padlockcrypto.padlock_pmm_available()
		self.available2 = _padlockcrypto.padlock_pmm_available()
	def pmm(self,A,B,M,length):
		if isinstance(A,str) and isinstance(B,str) and isinstance(M,str) and isinstance(length,int) and A.isalnum() and B.isalnum() and M.isalnum():
			dst,stat = _padlockcrypto.python_pmm(A,B,M,length)
		else:
			dst = 'err'
			stat = 0
		return (dst,stat)
			



